// Toasts

// Base Style
.toast {
  display: flex;
  justify-content: center;
  flex-direction: column;
  max-width: $toast-max-width;
  min-width: $toast-min-width;
  max-height: $toast-max-height;
  overflow: hidden; // cheap rounded corners on nested items
  @include font-size($toast-font-size);
  color: $toast-color;
  background-color: $toast-background-color;
  background-clip: padding-box;
  border: $toast-border-width solid $toast-border-color;
  box-shadow: $toast-box-shadow;
  backdrop-filter: blur(10px);
  opacity: 0;
  @include border-radius($toast-border-radius);
  @include set-animation($toast-animation-name);

  &:not(:last-child) {
    margin-bottom: $toast-spacer;
  }

  &.showing {
    opacity: 1;
  }

  &.show {
    display: flex;
    opacity: 1;
  }

  &.hide {
    display: none;
  }

  * {
    cursor: pointer;
  }
}

.toast-caption {
  position: absolute;
  right: $toast-spacer / 2;
  bottom: 1px;
  color: $toast-caption-color;
  @include font-size($toast-caption-size);
  font-weight: $font-weight-lighter;
}

.toast-close {
  position: absolute;
  top: 0;
  right: $toast-spacer / 2;
  color: $toast-color;
  @include font-size($font-size-md);
  cursor: pointer;
}

.toast-body {
  display: flex;
  align-items: center;
  flex: 1 1 auto;
  padding: $toast-body-padding;
}

.toast-icon {
  color: $toast-background-color;
  background-color: $toast-color;
  border-radius: 50%;
  text-align: center;
  @include font-size($toast-icon-size);
  margin: $toast-icon-margin;
  padding: 0 $toast-icon-padding-x;
  width: $toast-icon-width;
  height: $toast-icon-height;
  border: $toast-border-width solid $toast-color;
}

.toast-text {
  color: $toast-color;
  display: flex;
  flex-direction: column;
  justify-content: center;
  padding: ($toast-spacer / 2) $toast-spacer ($toast-spacer / 2) 0;
}

.toast-title {
  @include font-size($font-size-md);
  font-weight: $font-weight-medium;
}

.toast-message {
  @include font-size($font-size-sm);
  font-weight: $font-weight-lighter;
  line-height: 1.2;
}

// Toast-Size
.toast-sm {
  width: $toast-width-sm;
  height: $toast-height-sm;

  .toast-icon {
    width: $toast-icon-width-sm;
    height: $toast-icon-height-sm;
    @include font-size($font-size-md);
  }
}

// Toast Variant

@each $color, $value in $theme-colors {
  .toast-#{$color} {
    @include toast-variant($value);
  }
}

// Icon colors
@each $color, $value in $theme-colors {
  .toast-icon-#{$color} {
    background-color: $value;
    border-color: $value;
    box-shadow: $toast-icon-box-shadow rgba($value, .4);
  }
}
